#ifndef __SEARCH_H__
#define __SEARCH_H__
#ifdef __cplusplus
extern "C" {
#endif
/* Copyright (C) 1989 Silicon Graphics, Inc. All rights reserved.  */
/* ------------------------------------------------------------------ */
/* | Copyright Unpublished, MIPS Computer Systems, Inc.  All Rights | */
/* | Reserved.  This software contains proprietary and confidential | */
/* | information of MIPS and its suppliers.  Use, disclosure or     | */
/* | reproduction is prohibited without the prior express written   | */
/* | consent of MIPS.                                               | */
/* ------------------------------------------------------------------ */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident "$Revision: 1.9 $"

#include <stddef.h>

/* bsearch(3C) is ANSI, and is replicated in stdlib.h */
extern void * bsearch(const void *, const void *, size_t,
			  size_t, int (*) (const void *, const void *));

/* HSEARCH(3C) */
typedef struct entry { char *key, *data; } ENTRY;
typedef enum { FIND, ENTER } ACTION;

extern ENTRY *	hsearch(ENTRY,ACTION);
extern int	hcreate(unsigned);
extern void	hdestroy(void);

/* LSEARCH(3C) */
extern void *	lsearch(const void *,  void *, unsigned *,
			  size_t, int (*) (const void *, const void *));

extern void *	lfind(const void *, void *, unsigned *,
			  size_t, int (*) (const void *, const void *));

/* TSEARCH(3C) */
enum __visit_e { preorder, postorder, endorder, leaf } ;
typedef  enum __visit_e VISIT;

extern void *	tsearch(const void *, void * *,
			  int (*) (const void *, const void *));
extern void *	tfind(const void *, void * * ,
			  int (*) (const void *, const void *));
extern void *	tdelete(const void *, void * *,
			  int (*) (const void *, const void *));

extern void	twalk(void *, void (*)(void *, VISIT, int));

#ifdef __cplusplus
}
#endif
#endif /* !__SEARCH_H__ */
