#ifndef __SETJMP_H__
#define __SETJMP_H__
#ifdef __cplusplus
extern "C" {
#endif
/* Copyright (C) 1989 Silicon Graphics, Inc. All rights reserved.  */
/* ------------------------------------------------------------------ */
/* | Copyright Unpublished, MIPS Computer Systems, Inc.  All Rights | */
/* | Reserved.  This software contains proprietary and confidential | */
/* | information of MIPS and its suppliers.  Use, disclosure or     | */
/* | reproduction is prohibited without the prior express written   | */
/* | consent of MIPS.                                               | */
/* ------------------------------------------------------------------ */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* #ident "$Revision: 1.19 $" */

/* ANSI C Notes:
 *
 * - THE IDENTIFIERS APPEARING OUTSIDE OF #ifdef __EXTENSIONS__ IN THIS
 *   standard header ARE SPECIFIED BY ANSI!  CONFORMANCE WILL BE ALTERED
 *   IF ANY NEW IDENTIFIERS ARE ADDED TO THIS AREA UNLESS THEY ARE IN ANSI's
 *   RESERVED NAMESPACE. (i.e., unless they are prefixed by __[a-z] or
 *   _[A-Z].  For external objects, identifiers with the prefix _[a-z] 
 *   are also reserved.)
 */

#define _JBLEN	28

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)
typedef int	jmp_buf[_JBLEN];
extern int	setjmp(jmp_buf);
extern void	longjmp(jmp_buf, int);
#endif /* _LANGUAGE_C || _LANGUAGE_C_PLUS_PLUS */

#if (defined(__EXTENSIONS__) || defined(_POSIX_SOURCE))
/*
 * jmp_buf offsets
 *
 * NOTE: entries between JB_ONSIGSTK and JB_V0 must match struct sigcontext.
 * See libc routines setjmp/longjmp, signal, and kernel routines
 * sendsig/sigcleanup.
 */
#define	JB_ONSIGSTK	0	/* onsigstack flag */
#define	JB_SIGMASK	1	/* signal mask */
#define	JB_SP		2	/* stack pointer */
#define	JB_PC		3	/* program counter */
#define	JB_V0		4	/* longjmp retval */
#define	JB_S0		5	/* callee saved regs.... */
#define	JB_S1		6
#define	JB_S2		7
#define	JB_S3		8
#define	JB_S4		9
#define	JB_S5		10
#define	JB_S6		11
#define	JB_S7		12
#define	JB_S8		13	/* frame pointer */
#define	JB_F20		14	/* callee save regs */
#define	JB_F21		15
#define	JB_F22		16
#define	JB_F23		17
#define	JB_F24		18
#define	JB_F25		19
#define	JB_F26		20
#define	JB_F27		21
#define	JB_F28		22
#define	JB_F29		23
#define	JB_F30		24
#define	JB_F31		25
#define JB_FPC_CSR	26	/* fp control and status register */
#define	JB_MAGIC	27

#define	JB_FP		13	/* frame pointer -- obsolete */

#define	JBMAGIC		0xacedbade

#define	NJBREGS		_JBLEN

/* for JB_ONSIGSTK */
#define	JB_ONSIGSTK_SVMASK	0x1		/* need to save/restore mask */
#define	JB_ONSIGSTK_ONSTACK	0x2		/* on sigstack */

#if (defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS))
#define sigsetjmp	_sigsetjmp
typedef jmp_buf sigjmp_buf;	/* POSIX wants it called sigjmp_buf. */
extern int	sigsetjmp(sigjmp_buf, int);
extern void	siglongjmp(sigjmp_buf, int);
extern int	_setjmp(jmp_buf);
extern void	_longjmp(jmp_buf, int);

#if ((defined(_BSD_SIGNALS) || defined(_BSD_COMPAT)) && !defined(_POSIX_SOURCE))
#define setjmp	BSDsetjmp
#define longjmp	BSDlongjmp
extern int	BSDsetjmp(jmp_buf);
extern void	BSDlongjmp(jmp_buf, int);
#endif /* _BSD_SIGNALS || _BSD_COMPAT && !_POSIX_SOURCE */
#endif /* _LANGUAGE_C || _LANGUAGE_C_PLUS_PLUS */

#endif /* __EXTENSIONS__ || _POSIX_SOURCE */

#ifdef __cplusplus
}
#endif
#endif /* !__SETJMP_H__ */
