#ifndef __STDDEF_H__
#define __STDDEF_H__

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

/* #ident "$Revision: 1.11 $" */

/* ANSI C Notes:
 *
 * - THE IDENTIFIERS APPEARING OUTSIDE OF #ifdef __EXTENSIONS__ IN THIS
 *   standard header ARE SPECIFIED BY ANSI!  CONFORMANCE WILL BE ALTERED
 *   IF ANY NEW IDENTIFIERS ARE ADDED TO THIS AREA UNLESS THEY ARE IN ANSI's
 *   RESERVED NAMESPACE. (i.e., unless they are prefixed by __[a-z] or
 *   _[A-Z].  For external objects, identifiers with the prefix _[a-z] 
 *   are also reserved.)
 */

#ifndef NULL
#define NULL	0
#endif

/* The type of the result of subtracting two pointers. */
typedef int ptrdiff_t;

/* The type of the result of the sizeof operator. */
#ifndef _SIZE_T_
#define _SIZE_T_
typedef unsigned size_t;
#endif /* !_SIZE_T_ */

/*
 * wchar_t is an integral type whose range of values can represent distinct
 * codes for all members of the largest extended character set among the
 * supported locales.
 */
#ifndef _WCHAR_T_
#define _WCHAR_T_
typedef unsigned char wchar_t;
#endif /* !_WCHAR_T_ */

/*
 * Offset in bytes to the structure member "__fld" from the beginning of
 * the structure "__strty".
 */
#define offsetof(__strty,__fld)   ((size_t)(&(((__strty *)0)->__fld)))

#endif /* !__STDDEF_H__ */

