#ifndef __SYS_IP20_H__
#define	__SYS_IP20_H__

#ifdef	_MIPSEB

#define	CPUCTRL0	0x1fa00004	/* CPU control 0 (w, rw) */
#define	CPUCTRL1	0x1fa0000c	/* CPU control 1 (w, rw) */
#define	DOGC		0x1fa00014	/* watchdog timer (w, ro) */
#define	DOGR		DOGC		/* watchdog timer clear	(w, w) */
#define	SYSID		0x1fa0001c	/* system ID register (w, ro) */
#define	RPSS_DIVIDER	0x1fa0002c	/* RPSS divider register (w, rw) */
#define	EEROM		0x1fa00034	/* R4000 EEROM interface (b, rw) */
#define	CTRLD		0x1fa00044	/* refresh counter preload value (h, rw)
					 */
#define	REF_CTR		0x1fa0004c	/* refresh counter (h, ro) */
#define	GIO64_ARB	0x1fa00084	/* GIO64 arbitration parameters (h, rw)
					 */
#define	CPU_TIME	0x1fa0008c	/* arbiter CPU time period (h, rw) */
#define	LB_TIME		0x1fa0009c	/* arbiter long burst time period 
					   (h, rw) */
#define	MEMCFG0		0x1fa000c4	/* memory size configuration register 0
					   (w, rw) */
#define	MEMCFG1		0x1fa000cc	/* memory size configuration register 1
					   (w, rw) */
#define	CPU_MEMACC	0x1fa000d4	/* CPU main memory access configuration
					   parameters (w, rw) */
#define	GIO_MEMACC	0x1fa000dc	/* GIO main memory access configuration
					   parameters (w, rw) */
#define	CPU_ERR_ADDR	0x1fa000e4	/* CPU error address (w, ro) */
#define	CPU_ERR_STAT	0x1fa000ec	/* CPU error status (w, rw) */
#define	GIO_ERR_ADDR	0x1fa000f4	/* GIO error address (w, ro) */
#define	GIO_ERR_STAT	0x1fa000fc	/* GIO error status (w, rw) */
#define	SYS_SEMAPHORE	0x1fa00104	/* system semaphore (1 bit, rw) */
#define	LOCK_MEMORY	0x1fa0010c	/* lock GIO out of memory (1 bit, rw) */
#define	EISA_LOCK	0x1fa00114	/* lock EISA bus (1 bit, rw) */
#define	DMA_GIO_MASK	0x1fa00154	/* mask to translate GIO64 address
					   (w, rw) */
#define	DMA_GIO_SUB	0x1fa0015c	/* substitution bits for translating
					   GIO64 address (w, rw) */
#define	DMA_CAUSE	0x1fa00164	/* DMA interrupt cause (w, rw) */
#define	DMA_CTL		0x1fa0016c	/* DMA control, (w, rw) */
#define	DMA_TLB_HI_0	0x1fa00184	/* DMA TLB entry 0 high (w, rw) */
#define	DMA_TLB_LO_0	0x1fa0018c	/* DMA TLB entry 0 low (w, rw) */
#define	DMA_TLB_HI_1	0x1fa00194	/* DMA TLB entry 1 high (w, rw) */
#define	DMA_TLB_LO_1	0x1fa0019c	/* DMA TLB entry 1 low (w, rw) */
#define	DMA_TLB_HI_2	0x1fa001a4	/* DMA TLB entry 2 high (w, rw) */
#define	DMA_TLB_LO_2	0x1fa001ac	/* DMA TLB entry 2 low (w, rw) */
#define	DMA_TLB_HI_3	0x1fa001b4	/* DMA TLB entry 3 high (w, rw) */
#define	DMA_TLB_LO_3	0x1fa001bc	/* DMA TLB entry 3 low (w, rw) */
#define	RPSS_CTR	0x1fa01004	/* RPSS 100 nsec counter (w, ro) */
#define	DMA_MEMADR	0x1fa02004	/* DMA memory address (w, rw) */
#define	DMA_MEMADRD	0x1fa0200c	/* DMA memory address and set defaults
					   parameters (w, w) */
#define	DMA_SIZE	0x1fa02014	/* DMA line count and width (w, rw) */
#define	DMA_STRIDE	0x1fa0201c	/* DMA line zoom and stride (w, rw) */
#define	DMA_GIO_ADR	0x1fa02024	/* DMA GIO64 address, do not start DMA
					   (w, rw) */
#define	DMA_GIO_ADRS	0x1fa0202c	/* DMA GIO64 address and strat DMA 
					   (w, w) */
#define	DMA_MODE	0x1fa02034	/* DMA mode (w, rw) */
#define	DMA_COUNT	0x1fa0203c	/* DMA zoom count and byte count (w, rw)
					 */
#define	DMA_STDMA	0x1fa02044	/* start virtual DMA (w, rw) */
#define	DMA_RUN		0x1fa0204c	/* virtual DMA is running (w, ro) */
#define DMA_MEMADRDS	0x1fa02074	/* DMA memory address, set defaults
					   parameters, and start DMA (w, w)*/
#define	SEMAPHORE_0	0x1fa10004	/* semaphore 0 (1 bit, rw) */
#define	SEMAPHORE_1	0x1fa11004	/* semaphore 1 (1 bit, rw) */
#define	SEMAPHORE_2	0x1fa12004	/* semaphore 2 (1 bit, rw) */
#define	SEMAPHORE_3	0x1fa13004	/* semaphore 3 (1 bit, rw) */
#define	SEMAPHORE_4	0x1fa14004	/* semaphore 4 (1 bit, rw) */
#define	SEMAPHORE_5	0x1fa15004	/* semaphore 5 (1 bit, rw) */
#define	SEMAPHORE_6	0x1fa16004	/* semaphore 6 (1 bit, rw) */
#define	SEMAPHORE_7	0x1fa17004	/* semaphore 7 (1 bit, rw) */
#define	SEMAPHORE_8	0x1fa18004	/* semaphore 8 (1 bit, rw) */
#define	SEMAPHORE_9	0x1fa19004	/* semaphore 9 (1 bit, rw) */
#define	SEMAPHORE_10	0x1fa1a004	/* semaphore 10 (1 bit, rw) */
#define	SEMAPHORE_11	0x1fa1b004	/* semaphore 11 (1 bit, rw) */
#define	SEMAPHORE_12	0x1fa1c004	/* semaphore 12 (1 bit, rw) */
#define	SEMAPHORE_13	0x1fa1d004	/* semaphore 13 (1 bit, rw) */
#define	SEMAPHORE_14	0x1fa1e004	/* semaphore 14 (1 bit, rw) */
#define	SEMAPHORE_15	0x1fa1f004	/* semaphore 15 (1 bit, rw) */

#else	/* little endian */

#define	CPUCTRL0	0x1fa00000	/* CPU control 0 (w, rw) */
#define	CPUCTRL1	0x1fa00008	/* CPU control 1 (w, rw) */
#define	DOGC		0x1fa00010	/* watchdog timer (w, ro) */
#define	DOGR		DOGC		/* watchdog timer clear	(w, w) */
#define	SYSID		0x1fa00018	/* system ID register (w, ro) */
#define	RPSS_DIVIDER	0x1fa00028	/* RPSS divider register (w, rw) */
#define	EEROM		0x1fa00030	/* R4000 EEROM interface (b, rw) */
#define	CTRLD		0x1fa00040	/* refresh counter preload value (h, rw)
					 */
#define	REF_CTR		0x1fa00048	/* refresh counter (h, ro) */
#define	GIO64_ARB	0x1fa00080	/* GIO64 arbitration parameters (h, rw)
					 */
#define	CPU_TIME	0x1fa00088	/* arbiter CPU time period (h, rw) */
#define	LB_TIME		0x1fa00098	/* arbiter long burst time period 
					   (h, rw) */
#define	MEMCFG0		0x1fa000c0	/* memory size configuration register 0
					   (w, rw) */
#define	MEMCFG1		0x1fa000c8	/* memory size configuration register 1
					   (w, rw) */
#define	CPU_MEMACC	0x1fa000d0	/* CPU main memory access configuration
					   parameters (w, rw) */
#define	GIO_MEMACC	0x1fa000d8	/* GIO main memory access configuration
					   parameters (w, rw) */
#define	CPU_ERR_ADDR	0x1fa000e0	/* CPU error address (w, ro) */
#define	CPU_ERR_STAT	0x1fa000e8	/* CPU error status (w, rw) */
#define	GIO_ERR_ADDR	0x1fa000f0	/* GIO error address (w, ro) */
#define	GIO_ERR_STAT	0x1fa000f8	/* GIO error status (w, rw) */
#define	SYS_SEMAPHORE	0x1fa00100	/* system semaphore (1 bit, rw) */
#define	LOCK_MEMORY	0x1fa00108	/* lock GIO out of memory (1 bit, rw) */
#define	EISA_LOCK	0x1fa00110	/* lock EISA bus (1 bit, rw) */
#define	DMA_GIO_MASK	0x1fa00150	/* mask to translate GIO64 address
					   (w, rw) */
#define	DMA_GIO_SUB	0x1fa00158	/* substitution bits for translating
					   GIO64 address (w, rw) */
#define	DMA_CAUSE	0x1fa00160	/* DMA interrupt cause (w, rw) */
#define	DMA_CTL		0x1fa00168	/* DMA control, (w, rw) */
#define	DMA_TLB_HI_0	0x1fa00180	/* DMA TLB entry 0 high (w, rw) */
#define	DMA_TLB_LO_0	0x1fa00188	/* DMA TLB entry 0 low (w, rw) */
#define	DMA_TLB_HI_1	0x1fa00190	/* DMA TLB entry 1 high (w, rw) */
#define	DMA_TLB_LO_1	0x1fa00198	/* DMA TLB entry 1 low (w, rw) */
#define	DMA_TLB_HI_2	0x1fa001a0	/* DMA TLB entry 2 high (w, rw) */
#define	DMA_TLB_LO_2	0x1fa001a8	/* DMA TLB entry 2 low (w, rw) */
#define	DMA_TLB_HI_3	0x1fa001b0	/* DMA TLB entry 3 high (w, rw) */
#define	DMA_TLB_LO_3	0x1fa001b8	/* DMA TLB entry 3 low (w, rw) */
#define	RPSS_CTR	0x1fa01000	/* RPSS 100 nsec counter (w, ro) */
#define	DMA_MEMADR	0x1fa02000	/* DMA memory address (w, rw) */
#define	DMA_MEMADRD	0x1fa02008	/* DMA memory address and set defaults
					   parameters (w, w) */
#define	DMA_SIZE	0x1fa02010	/* DMA line count and width (w, rw) */
#define	DMA_STRIDE	0x1fa02018	/* DMA line zoom and stride (w, rw) */
#define	DMA_GIO_ADR	0x1fa02020	/* DMA GIO64 address, do not start DMA
					   (w, rw) */
#define	DMA_GIO_ADRS	0x1fa02028	/* DMA GIO64 address and strat DMA 
					   (w, w) */
#define	DMA_MODE	0x1fa02030	/* DMA mode (w, rw) */
#define	DMA_COUNT	0x1fa02038	/* DMA zoom count and byte count (w, rw)
					 */
#define	DMA_STDMA	0x1fa02040	/* start virtual DMA (w, rw) */
#define	DMA_RUN		0x1fa02048	/* virtual DMA is running (w, ro) */
#define DMA_MEMADRDS	0x1fa02070	/* DMA memory address, set defaults
					   parameters, and start DMA (w, w)*/
#define	SEMAPHORE_0	0x1fa10000	/* semaphore 0 (1 bit, rw) */
#define	SEMAPHORE_1	0x1fa11000	/* semaphore 1 (1 bit, rw) */
#define	SEMAPHORE_2	0x1fa12000	/* semaphore 2 (1 bit, rw) */
#define	SEMAPHORE_3	0x1fa13000	/* semaphore 3 (1 bit, rw) */
#define	SEMAPHORE_4	0x1fa14000	/* semaphore 4 (1 bit, rw) */
#define	SEMAPHORE_5	0x1fa15000	/* semaphore 5 (1 bit, rw) */
#define	SEMAPHORE_6	0x1fa16000	/* semaphore 6 (1 bit, rw) */
#define	SEMAPHORE_7	0x1fa17000	/* semaphore 7 (1 bit, rw) */
#define	SEMAPHORE_8	0x1fa18000	/* semaphore 8 (1 bit, rw) */
#define	SEMAPHORE_9	0x1fa19000	/* semaphore 9 (1 bit, rw) */
#define	SEMAPHORE_10	0x1fa1a000	/* semaphore 10 (1 bit, rw) */
#define	SEMAPHORE_11	0x1fa1b000	/* semaphore 11 (1 bit, rw) */
#define	SEMAPHORE_12	0x1fa1c000	/* semaphore 12 (1 bit, rw) */
#define	SEMAPHORE_13	0x1fa1d000	/* semaphore 13 (1 bit, rw) */
#define	SEMAPHORE_14	0x1fa1e000	/* semaphore 14 (1 bit, rw) */
#define	SEMAPHORE_15	0x1fa1f000	/* semaphore 15 (1 bit, rw) */

#endif	/* _MIPSEB */

/* CPU control register 0, CPUCTRL0 */
#define	CPUCTRL0_REFS_MASK	0x0000000f	/* mask for the REFS field */
#define	CPUCTRL0_RFE		0x00000010	/* enable memory refresh */
#define	CPUCTRL0_GPR		0x00000020	/* enable parity error reporting
						   on GOI64 transactions */
#define	CPUCTRL0_MPR		0x00000040	/* enable parity reporting on
						   main memory */
#define	CPUCTRL0_CPR		0x00000080	/* enable parity error reporting
						   on CPU bus transactions */
#define	CPUCTRL0_DOG		0x00000100	/* enable watchdog timer */
#define	CPUCTRL0_SIN		0x00000200	/* system initialization */
#define	CPUCTRL0_GRR		0x00000400	/* graphics reset */
#define	CPUCTRL0_EN_LOCK	0x00000800	/* enable EISA to lock memory
						   from the CPU */
#define	CPUCTRL0_CMD_PAR	0x00001000	/* enable parity error reporting
						   on syscmd bus */
#define	CPUCTRL0_INT_EN		0x00002000	/* enable interrupt writes from
						   MC */
#define	CPUCTRL0_SNOOP_EN	0x00004000	/* enable snoop logic for I/O
						   request, if implemented */
#define	CPUCTRL0_PROM_WR_EN	0x00008000	/* enable CPU writes to the
						   boot PROM */
#define	CPUCTRL0_WR_ST		0x00010000	/* warm reset without killing
						   memory refresh */
#define	CPUCTRL0_LITTLE		0x00040000	/* configure the MC to run in
						   little endian mode */
#define	CPUCTRL0_WRST		0x00080000	/* warm reset */
#define	CPUCTRL0_BAD_PAR	0x02000000	/* generate bad parity on data
						   written by CPU to memory */
#define	CPUCTRL0_R4K_CHK_PAR_N	0x04000000	/* R4000 not to check parity
						   on memory read data */
#define	CPUCTRL0_BACK2		0x08000000	/* enable back to back GIO64
						   write with no dead tristate
						   cycles between MC and MUX */

#define CPU_CONFIG		CPUCTRL0
#define CONFIG_GRRESET		CPUCTRL0_GRR

/* CPU control register 1, CPUCTRL1 */
#define	CPUCTRL1_ABORT_EN	0x00000010	/* enable GIO bus time outs */
#define	CPUCTRL1_HPC_FX		0x00001000	/* HPC endianess is fixed */
#define	CPUCTRL1_HPC_LITTLE	0x00002000	/* HPC is little endian */
#define	CPUCTRL1_EXP0_FX	0x00004000	/* EXP0 endianess is fixed */
#define	CPUCTRL1_EXP0_LITTLE	0x00008000	/* EXP0 is little endian */
#define	CPUCTRL1_EXP1_FX	0x00010000	/* EXP1 endianess is fixed */
#define	CPUCTRL1_EXP1_LITTLE	0x00020000	/* EXP1 is little endian */

/* system ID register, SYSID */
#define	SYSID_CHIP_REV_MASK	0x0000000f	/* MC chip revision mask */
#define	SYSID_EISA_PRESENT	0x00000010	/* EISA bus is present */

/* R4000 configuration EEROM interface, EEROM */
#define	EEROM_CS	0x00000002	/* EEROM chip select. active high */
#define	EEROM_SCK	0x00000004	/* serial EEROM clock */
#define	EEROM_SO	0x00000008	/* data to serial EEROM */
#define	EEROM_SI	0x00000010	/* data from serial EEROM */

/* arbitration parameters, GIO64_ARB */
#define	GIO64_ARB_HPC_SIZE_64	0x00000001	/* width of data transfer to
						   HPC is 64 bits */
#define	GIO64_ARB_GRX_SIZE_64	0x00000002	/* width of data transfer to
						   graphics is 64 bits */
#define	GIO64_ARB_EXP0_SIZE_64	0x00000004	/* width of data transfer to
						   GIO64 slot 0 is 64 bits */
#define	GIO64_ARB_EXP1_SIZE_64	0x00000008	/* width of data transfer to
						   GIO64 slot 1 is 64 bits */
#define	GIO64_ARB_EISA_SIZE	0x00000010	/* width of data transfer to the
						   EISA bus is 64 bits */
#define	GIO64_ARB_GRX_RT	0x00000040	/* graphics is a real time
						   device */
#define	GIO64_ARB_EXP0_RT	0x00000080	/* GIO64 slot 0 is a real time
						   device */
#define	GIO64_ARB_EXP1_RT	0x00000100	/* GIO64 slot 1 is a real time
						   device */
#define	GIO64_ARB_EISA_MST	0x00000200	/* EISA bus can be a GIO64 bus
						   master */
#define	GIO64_ARB_1_GIO		0x00000400	/* there is only one pipelined
						   GIO64 bus */
#define	GIO64_ARB_GRX_MST	0x00000800	/* graphics can be a GIO64 bus
						   master */
#define	GIO64_ARB_EXP0_MST	0x00001000	/* GIO64 slot 0 can be a GIO64
						   bus master */
#define	GIO64_ARB_EXP1_MST	0x00002000	/* GIO64 slot 1 can be a GIO64
						   bus master */
#define	GIO64_ARB_EXP0_PIPED	0x00004000	/* GIO64 slot 0 is a pipelined
						   device */
#define	GIO64_ARB_EXP1_PIPED	0x00008000	/* GIO64 slot 1 is a pipelined
						   device */

/* memory configuration registers, MEMCFG0, MEMCFG1 */
#define	MEMCFG_4MRAM		0x0000	/* 4 MB of RAM */
#define	MEMCFG_8MRAM		0x0100	/* 8 MB of RAM */
#define	MEMCFG_16MRAM		0x0300	/* 16 MB of RAM */
#define	MEMCFG_32MRAM		0x0700	/* 32 MB of RAM */
#define	MEMCFG_64MRAM		0x0f00	/* 64 MB of RAM */
#define	MEMCFG_128MRAM		0x1f00	/* 128 MB of RAM */
#define	MEMCFG_DRAM_MASK	0x1f00	/* DRAM mask */

#define	MEMCFG_ADDR_MASK	0x00ff	/* ADDR mask */
#define	MEMCFG_VLD		0x2000	/* bank is valid */
#define	MEMCFG_BNK		0x4000	/* 2 subbanks */

#define	ERR_STAT_B0		0x00000001
#define	ERR_STAT_B1		0x00000002
#define	ERR_STAT_B2		0x00000004
#define	ERR_STAT_B3		0x00000008
#define	ERR_STAT_B4		0x00000010
#define	ERR_STAT_B5		0x00000020
#define	ERR_STAT_B6		0x00000040
#define	ERR_STAT_B7		0x00000080

/* CPU error status, CPU_ERR_STAT */
#define	CPU_ERR_STAT_RD		0x00000100	/* read parity error */
#define	CPU_ERR_STAT_PAR	0x00000200	/* CPU parity error */
#define	CPU_ERR_STAT_ADDR	0x00000400	/* memory bus error. bad
						   address */
#define	CPU_ERR_STAT_SYSAD_PAR	0x00000800	/* sysad parity error */
#define	CPU_ERR_STAT_SYSCMD_PAR	0x00001000	/* syscmd parity error */
#define	CPU_ERR_STAT_BAD_DATA	0x00002000	/* bad data identifier */

#define	CPU_ERR_STAT_PAR_MASK	0x00001f00	/* parity error mask */
#define	CPU_ERR_STAT_RD_PAR	(CPU_ERR_STAT_RD | CPU_ERR_STAT_PAR)

/* GIO error status, GIO_ERR_STAT */
#define	GIO_ERR_STAT_RD		0x00000100	/* read parity error */
#define	GIO_ERR_STAT_WR		0x00000200	/* write parity error */
#define	GIO_ERR_STAT_TIME	0x00000400	/* GIO bus timed out */
#define	GIO_ERR_STAT_PROM	0x00000800	/* write to PROM when PROM_EN
						   not set */
#define	GIO_ERR_STAT_ADDR	0x00001000	/* parity errror on address
						   cycle */
#define	GIO_ERR_STAT_BC		0x00002000	/* parity errror on byte count
						   cycle */

#define	CPU_TIME_DEFAULT	0x002b		/* ~1.3 us, GIO delay, 33MHz */
#define	LB_TIME_DEFAULT		0x034f		/* ~25.4us, GIO burst, 33MHz */

#define PHYS_RAMBASE            0x08000000
#define K0_RAMBASE              PHYS_TO_K0(PHYS_RAMBASE)
#define K1_RAMBASE              PHYS_TO_K1(PHYS_RAMBASE)
#define PHYS_TO_K0_RAM(x)       PHYS_TO_K0((x)+PHYS_RAMBASE)
#define PHYS_TO_K1_RAM(x)       PHYS_TO_K1((x)+PHYS_RAMBASE)
#define SYMMON_STACK            PHYS_TO_K0_RAM(0x3000)
#define PROM_STACK              PHYS_TO_K1_RAM(0x800000)
#define PROM_BSS                PHYS_TO_K1_RAM(0x740000)
#define PROM_CHILD_STACK        (PROM_BSS-4)
#define RESTART_ADDR		PHYS_TO_K0_RAM(0x400)

#define	FIRSTCLICK	btoc(128*1024*1024)

/* Size definitions */
#define SYMMON_PDASIZE          512     /* size per CPU */

#define	CAUSE_BERRINTR	CAUSE_IP7	/* bus error interrupt */
#define	SR_BERRBIT	SR_IBIT7	/* bus error interrupt enable */

/* 
 * Local I/O Interrupt Status Register  (INT2)
 */
#ifdef	_MIPSEB
#define LIO_0_ISR_ADDR	0x1fb801c3	/* Local IO interrupt status (b,ro) */
#define LIO_1_ISR_ADDR	0x1fb801cb	/* Local IO interrupt status (b,ro) */
#else	/* _MIPSEL */
#define LIO_0_ISR_ADDR	0x1fb801c0	/* Local IO interrupt status (b,ro) */
#define LIO_1_ISR_ADDR	0x1fb801c8	/* Local IO interrupt status (b,ro) */
#endif	/* _MIPSEL */

/* LIO 0 status bits */
#define LIO_FIFO	0x01		/* FIFO full / GIO-0  interrupt */
#define LIO_GIO_0	0x01
#define LIO_CENTR	0x02		/* Centronics Printer Interrupt */
#define LIO_SCSI	0x04		/* SCSI interrupt */
#define LIO_ENET	0x08		/* Ethernet interrupt */
#define LIO_GDMA	0x10		/* Graphics dma done interrupt */
#define LIO_DUART	0x20		/* Duart interrupts (OR'd) */
#define LIO_GE		0x40		/* GE/GIO-1/second HPC1 interrupt */
#define LIO_GIO_1	0x40
#define LIO_VME0	0x80		/* VME-0 interrupt */

/* LIO 1 status bits */
#define LIO_BIT0_UNUSED	0x01
#define LIO_GR1MODE	0x02		/* GR1 Mode(IP20)/Case Interlock(HP1) */
#define LIO_BIT2_UNUSED	0x04
#define LIO_VME1	0x08		/* VME-1 interrupt */
#define LIO_DSP		0x10		/* DSP interrupt */
#define LIO_AC		0x20		/* ACFAIL interrupt */
#define LIO_VIDEO	0x40		/* Video option interrupt */
#define LIO_VR		0x80		/* Vert retrace / GIO-2 interrupt */
#define LIO_GIO_2	0x80

/* 
 * Local I/O Interrupt Mask Register  (INT2)
 */
#ifdef	_MIPSEB
#define LIO_0_MASK_ADDR	0x1fb801c7	/* Local IO register 0 mask (b) */
#define LIO_1_MASK_ADDR	0x1fb801cf	/* Local IO register 1 mask (b) */
#else	/* _MIPSEL */
#define LIO_0_MASK_ADDR	0x1fb801c4	/* Local IO register 0 mask (b) */
#define LIO_1_MASK_ADDR	0x1fb801cc	/* Local IO register 1 mask (b) */
#endif	/* _MIPSEL */

/* LIO 0 mask bits */
#define LIO_FIFO_MASK		0x01	/* FIFO full/GIO-0 interrupt mask */
#define LIO_CENTR_MASK		0x02	/* Centronics Printer Interrupt mask */
#define LIO_SCSI_MASK		0x04	/* SCSI interrupt mask */
#define LIO_ENET_MASK		0x08	/* Ethernet interrupt mask */
#define LIO_GDMA_MASK		0x10	/* Graphics DMA interrupt mask */
#define LIO_DUART_MASK		0x20	/* Duart interrupts mask*/
#define LIO_GE_MASK		0x40	/* GE/GIO-1 interrupt mask */
#define LIO_VME0_MASK		0x80	/* VME-0 interrupt mask */

/* LIO 1 mask bits */
#define LIO_MASK_BIT0_UNUSED	0x01
#define LIO_MASK_BIT1_UNUSED	0x02
#define LIO_MASK_BIT2_UNUSED	0x04
#define LIO_VME1_MASK		0x08	/* VME-1 interrupt */
#define LIO_DSP_MASK		0x10	/* DSP interrupt */
#define LIO_AC_MASK		0x20	/* AC fail interrupt */
#define LIO_VIDEO_MASK		0x40	/* Video option interrupt */
#define LIO_VR_MASK		0x80	/* Vert retrace/GIO-2 interrupt */

/* Local I/O vector numbers for setlclvector() (local 1 starts at 8) */
#define VECTOR_GIO0             0
#define VECTOR_PLP              1
#define VECTOR_SCSI             2
#define VECTOR_ENET             3
#define VECTOR_GDMA             4
#define VECTOR_DUART            5
#define VECTOR_GIO1             6
#define VECTOR_VME0             7
#define VECTOR_ILOCK            9
#define VECTOR_VME1             11
#define VECTOR_DSP              12
#define VECTOR_ACFAIL           13
#define VECTOR_VIDEO            14
#define VECTOR_GIO2             15

/* Local IO Segment */
#define LIO_ADDR        0x1f000000
#define LIO_GFX_SIZE    0x00400000      /* 4 Meg for graphics boards */
#define LIO_GIO_SIZE    0x00600000      /* 6 Meg for GIO Slots */

/* GIO Interrupts */
#define GIO_INTERRUPT_0         0
#define GIO_INTERRUPT_1         1
#define GIO_INTERRUPT_2         2

/* GIO Slots */
#define GIO_SLOT_0              0
#define GIO_SLOT_1              1
#define GIO_SLOT_GFX            2

/* Serial Port Configuration/LEDs
 *
 * On the HP1 board, the PORT_CONFIG register controls the configuration
 * of the serial ports and ethernet.  On IP20 it controls the LEDs.
 */
#ifdef	_MIPSEB
#define	PORT_CONFIG	0x1fb801df	/* LEDs/serial port config (5 bits) */
#else	/* _MIPSEL */
#define	PORT_CONFIG	0x1fb801dc	/* LEDs/serial port config (5 bits) */
#endif	/* _MIPSEL */

#define PCON_PARITY	0x01		/* IP20 cache parity error */
#define PCON_SERTCLK	0x01		/* External clock on for HP1 port 0 */
#define PCON_SER0RTS	0x02		/* RTS/TX+ for HP1 port 0 (RTS=1) */
#define PCON_SER1RTS	0x04		/* RTS/TX+ for HP1 port 1 (RTS=1) */
#define PCON_CLEARVRI	0x08		/* Disable/enable vert. retrace intr. */
#define PCON_POWER	0x10		/* Power off */

#define	LED_MASK	0x0e		/* led bits (3) */
#define	LED_HEART	0x02		/* 1 HZ Heartbeat */
#define LED_IDLE	0x04		/* off when cpu is idle */
#define LED_GFX		0x08

/* 
 * Clock and timer  (INT2)
 */
#define	PT_CLOCK_ADDR	PHYS_TO_K1(0x1fb801f0)	/* 8254 timer */
#ifdef	_MIPSEB
#define	TIMER_ACK_ADDR	PHYS_TO_K1(0x1fb801e3)	/* clear timer 2 bits (ws) */
#else	/* _MIPSEL */
#define	TIMER_ACK_ADDR	PHYS_TO_K1(0x1fb801e0)	/* clear timer 2 bits (ws) */
#endif	/* _MIPSEL */

#define ACK_TIMER0	0x1	/* write strobe to clear timer 0 */
#define ACK_TIMER1	0x2	/* write strobe to clear timer 1 */

/*
 * HPC ID register
 */
#define HPC_0_ID_ADDR	0x1fb80000	/* HPC 0 exists (primary HPC) */
#define HPC_1_ID_ADDR	0x1fb00000	/* HPC 1 exists */
#define HPC_2_ID_ADDR	0x1f980000	/* HPC 2 exists */
#define HPC_3_ID_ADDR	0x1f900000	/* HPC 3 exists */

/*
 * HPC Endianness register
 */
#ifdef	_MIPSEB
#define HPC_ENDIAN   	0x1fb800c3	/* dma endian settings (b) */
#else	/* _MIPSEL */
#define HPC_ENDIAN   	0x1fb800c0
#endif	/* _MIPSEL */

#define HPC_CPU_LITTLE	0x1		/* CPU little endian on reset */
#define HPC_ENET_LITTLE	0x2		/* Ethernet little endian */
#define HPC_SCSI_LITTLE	0x4		/* SCSI little endian */
#define HPC_PAR_LITTLE	0x8		/* Parallel little endian */
#define HPC_DSP_LITTLE	0x10		/* DSP little endian */
#define HPC_REV_MASK	0xc0		/* Rev = 01 for HPC1.5 */
#define HPC_REV_SHIFT	6

#define HPC_ALL_LITTLE  (HPC_CPU_LITTLE|HPC_ENET_LITTLE|HPC_SCSI_LITTLE| \
                         HPC_PAR_LITTLE|HPC_DSP_LITTLE)
#define HPC_ALL_BIG     (0)

/* 
 * Ethernet control (HPC1) - see bsd/misc/seeq.h
 */

/* 
 * SCSI Control (on HPC 0).  Always present.
 */
#define SCSI0_BC_ADDR	0x1fb80088	/* SCSI byte count register */
#define SCSI0_CBP_ADDR	0x1fb8008c	/* SCSI current buffer pointer */
#define SCSI0_NBDP_ADDR	0x1fb80090	/* SCSI next buffer pointer */
#define SCSI0_CTRL_ADDR	0x1fb80094	/* SCSI control register */

/* wc33c93 chip registers accessed through HPC1 */
#ifdef	_MIPSEB
#define SCSI0A_ADDR	0x1fb80122	/* SCSI WD33C93 address register (b) */
#define SCSI0D_ADDR	0x1fb80126	/* SCSI WD33C93 data register (b) */
#else	/* _MIPSEL */
#define SCSI0A_ADDR	0x1fb80121	/* SCSI WD33C93 address register (b) */
#define SCSI0D_ADDR	0x1fb80125	/* SCSI WD33C93 data register (b) */
#endif	/* _MIPSEL */

/* HPC1 registers for SCSI fifo */
#define SCSI0_PNTR_ADDR	0x1fb80098	/* SCSI pointer register */
#define SCSI0_FIFO_ADDR	0x1fb8009c	/* SCSI fifo data register */

/* 
 * 2nd SCSI Control (on HPC 1).  May not be present.
 */
#define SCSI1_BC_ADDR	0x1fb00088	/* SCSI byte count register */
#define SCSI1_CBP_ADDR	0x1fb0008c	/* SCSI current buffer pointer */
#define SCSI1_NBDP_ADDR	0x1fb00090	/* SCSI next buffer pointer */
#define SCSI1_CTRL_ADDR	0x1fb00094	/* SCSI control register */

/* wc33c93 chip registers accessed through HPC1 */
#ifdef	_MIPSEB
#define SCSI1A_ADDR	0x1fb00122	/* SCSI WD33C93 address register (b) */
#define SCSI1D_ADDR	0x1fb00126	/* SCSI WD33C93 data register (b) */
#else	/* _MIPSEL */
#define SCSI1A_ADDR	0x1fb00121	/* SCSI WD33C93 address register (b) */
#define SCSI1D_ADDR	0x1fb00125	/* SCSI WD33C93 data register (b) */
#endif	/* _MIPSEL */

/* HPC1 registers for SCSI fifo */
#define SCSI1_PNTR_ADDR	0x1fb00098	/* SCSI pointer register */
#define SCSI1_FIFO_ADDR	0x1fb0009c	/* SCSI fifo data register */


#define SCSI_RESET	0x01		/* reset WD33C93 chip */
#define SCSI_FLUSH	0x02		/* flush SCSI buffers */
#define SCSI_TO_MEM	0x10		/* transfer in */
#define SCSI_STARTDMA	0x80		/* start SCSI dma transfer */

/* 
 * Parallel control (HPC1)
 */
#define PAR_OFFSET	0xa8		/* offset to par regs from HPC1 */
#define PAR_BC_ADDR	0x1fb800a8	/* parallel byte count and IE (w) */
#define PAR_CBP_ADDR	0x1fb800ac	/* parallel current buf ptr (w) */
#define PAR_NBDP_ADDR	0x1fb800b0	/* parallel next buf desc (w) */
#define PAR_CTRL_ADDR	0x1fb800b4	/* parallel control reg (w) */
#ifdef	_MIPSEB
#define PAR_SR_ADDR	0x1fb80135	/* parallel status/remote reg (b) */
#else	/* _MIPSEL */
#define PAR_SR_ADDR	0x1fb80136	/* parallel status/remote reg (b) */
#endif	/* _MIPSEL */

/* parallel control register bits */
#define PAR_CTRL_RESET		0x01	/* reset parallel port */
#define PAR_CTRL_INT  		0x02	/* interrupt pending */
#define PAR_CTRL_CLRINT		0x02	/* clear pending interrupt */
#define PAR_CTRL_POLARITY	0x04	/* strobe polarity */
#define PAR_CTRL_SOFTACK	0x08	/* soft acknowledge */
#define PAR_CTRL_PPTOMEM	0x10	/* dma parallel port to mem */
#define PAR_CTRL_MEMTOPP	0x00	/* dma mem to parallel port */
#define PAR_CTRL_IGNACK		0x20	/* ignore ack input */
#define PAR_CTRL_FLUSH		0x40	/* flush HPC PP buffers */
#define PAR_CTRL_STRTDMA	0x80	/* start dma */

#define PAR_STROBE_MIN_MASK	0x7f000000  /* mask for strobe duty cycle */
#define PAR_STROBE_LEAD_MASK	0x007f0000  /* mask for strobe lead edge */
#define PAR_STROBE_TRAIL_MASK	0x00007f00  /* mask for strobe tailing edge */
#define PAR_STROBE_MASK		0x7f7f7f00  /* mask for strobe */

/*
 * DUART Registers (accessed through HPC1)
 */
#ifdef	_MIPSEB
#define DUART0  (0x1fb80d03 + K1BASE)
#define DUART1  (0x1fb80d13 + K1BASE)
#define DUART2  (0x1fb80d23 + K1BASE)
#define DUART3  (0x1fb80d33 + K1BASE)
#else	/* _MIPSEL */
#define DUART0  (0x1fb80d00 + K1BASE)
#define DUART1  (0x1fb80d10 + K1BASE)
#define DUART2  (0x1fb80d20 + K1BASE)
#define DUART3  (0x1fb80d30 + K1BASE)
#endif	/* _MIPSEL */

#define CHNA_DATA_OFFSET        0xc
#define CHNA_CNTRL_OFFSET       0x8
#define CHNB_DATA_OFFSET        0x4
#define CHNB_CNTRL_OFFSET       0x0

#define DUART0A_DATA    (DUART0 + CHNA_DATA_OFFSET)
#define DUART0B_DATA    (DUART0 + CHNB_DATA_OFFSET)
#define DUART1A_DATA    (DUART1 + CHNA_DATA_OFFSET)
#define DUART1B_DATA    (DUART1 + CHNB_DATA_OFFSET)
#define DUART2A_DATA    (DUART2 + CHNA_DATA_OFFSET)
#define DUART2B_DATA    (DUART2 + CHNB_DATA_OFFSET)

#define DUART0A_CNTRL   (DUART0 + CHNA_CNTRL_OFFSET)
#define DUART0B_CNTRL   (DUART0 + CHNB_CNTRL_OFFSET)
#define DUART1A_CNTRL   (DUART1 + CHNA_CNTRL_OFFSET)
#define DUART1B_CNTRL   (DUART1 + CHNB_CNTRL_OFFSET)
#define DUART2A_CNTRL   (DUART2 + CHNA_CNTRL_OFFSET)
#define DUART2B_CNTRL   (DUART2 + CHNB_CNTRL_OFFSET)

/*
 * Board revision register - modem SRAM memory space
 */
#define BOARD_REV_ADDR	0x1fbd0000
#define REV_HP1		0x8000
#define REV_MASK	0x7000
#define REV_SHIFT	12

/*
 * Headphone Gain MDACS (accessed like they're DUART3)
 */
#define HEADPHONE_MDAC_L	(DUART3 + CHNB_CNTRL_OFFSET)
#define HEADPHONE_MDAC_R	(DUART3 + CHNB_DATA_OFFSET)

/* 
 * Battery backup (real time) clock (accessed through HPC1)
 */
#ifdef LANGUAGE_C
#define RT_CLOCK_ADDR	(struct dp8573_clk *)PHYS_TO_K1(0x1fb80e00)
#else 
#define RT_CLOCK_ADDR	PHYS_TO_K1(0x1fb80e00)
#endif

/* 
 * CPU aux control register  (HPC1)
 */
#ifdef	_MIPSEB
#define	CPU_AUX_CONTROL	0x1fb801bf	/* Serial ctrl and LED (b) */
#else	/* _MIPSEL */
#define	CPU_AUX_CONTROL	0x1fb801bc	/* Serial ctrl and LED (b) */
#endif	/* _MIPSEL */

#define SER_TO_CPU	0x10		/* Data from serial memory */
#define CPU_TO_SER	0x08		/* Data to serial memory */
#define SERCLK		0x04		/* Serial Clock */
#define	CONSOLE_CS	0x02		/* EEPROM (nvram) chip select */
#define	CONSOLE_LED	0x01		/* Console led */
#define	NVRAM_PRE	0x01		/* EEPROM (nvram) PRE pin signal */

/* Locations of HDSP-HPC1 registers in the MIPS address space. */
#define HPC1DMAWDCNT	0x1fb80180	/* DMA transfer size (SRAM words) */
#define HPC1GIOADDL	0x1fb80184	/* GIO-bus address, LSB (16 bit) */
#define HPC1GIOADDM	0x1fb80188	/* GIO-bus address, MSB (16 bit) */
#define HPC1PBUSADD	0x1fb8018c	/* PBUS address (16 bit) */
#define HPC1DMACTRL	0x1fb80190	/* DMA Control (2 bit) */
#define HPC1COUNTER	0x1fb80194	/* Counter (24 bits) (ro) */
#define HPC1HANDTX	0x1fb80198	/* Handshake transmit (16 bit) */
#define HPC1HANDRX	0x1fb8019c	/* Handshake receive (16 bit) */
#define HPC1CINTSTAT	0x1fb801a0	/* CPU Interrupt status (3 bit) */
#define HPC1CINTMASK	0x1fb801a4	/* CPU Interrupt masks (3 bit) */
#define HPC1MISCSR	0x1fb801b0	/* Misc. control and status (8 bit) */
#define HPC1BURSTCTL	0x1fb801b4	/* DMA Ballistics register (16 bit)*/

/* Bits in HPC1DMACTRL */
#define HPC1DMA_GO	0x1		/* start dma */
#define HPC1DMA_DIR	0x2		/* direction: 0 = MIPS->DSP */
#define HPC1DMA_MODE	0x4		/* mode: 0 = normal, 1 = folded */

/* Bits in HPC1CINTSTAT */
#define HPC1CINT_DMA	0x1		/* end of dma */
#define HPC1CINT_TX	0x2		/* dsp has written to HANDTX */
#define HPC1CINT_RX	0x4		/* dsp has read HANDRX */

/* Bits in HPC1MISCSR */
#define HPC1MISC_RESET	0x1		/* force hard reset to DSP */
#define HPC1MISC_IRQA	0x2		/* force /IRQA with polarity below */
#define HPC1MISC_POL	0x4		/* polarity of IRQA (1 = high) */
#define HPC1MISC_32K	0x8		/* SRAM size (1=32K, 0=8K) */
/* Sign extension mode bits in HPC1MISCSR */
#define HPC1MISC_8TO32	0x70		/* PBus 8 -> GIO 32 signed */
#define HPC1MISC_16TO32	0x60		/* PBus 16 -> GIO 32 signed */
#define HPC1MISC_24TO32 0x40		/* PBus 24 -> GIO 32 signed */
#define HPC1MISC_NOSIGN 0x0		/* no sign extension */
/* 
 * DSP RAM access (accessed through HPC1)
 */
#define HPC1MEMORY	0x1fbe0000	/* DSP Memory 24 bits x 32k */

/*
 * VME interrupt control registers (INT2)
 */
/* VME Interrupt Status/Mask Registers */
#ifdef	_MIPSEB
#define VME_ISR_ADDR	0x1fb801d3	/* VME interrupt status (b, ro) */
#define VME_ISR		VME_ISR_ADDR	/* VME interrupt status (b) */
#define VME_0_MASK_ADDR	0x1fb801d7	/* VME interrupt mask for LIO 0 (b) */
#define VME_1_MASK_ADDR	0x1fb801db	/* VME interrupt mask for LIO 1 (b) */
#else	/* _MIPSEL */
#define VME_ISR_ADDR	0x1fb801d0	/* VME interrupt status (b, ro) */
#define VME_ISR		VME_ISR_ADDR	/* VME interrupt status (b) */
#define VME_0_MASK_ADDR	0x1fb801d4	/* VME interrupt mask for LIO 0 (b) */
#define VME_1_MASK_ADDR	0x1fb801d8	/* VME interrupt mask for LIO 1 (b) */
#endif	/* _MIPSEL */

/* 
 * Vertical retrace status (INT2)
 */
#define VRSTAT_ADDR	VME_ISR_ADDR	/* VR status read from vme reg */
#define VRSTAT_MASK	0x01		/* Vert retrace status: no interrupt */

#ifdef LANGUAGE_C

/*
 * Graphics DMA 
 */
#define GDMA_HTOG	0x0
#define GDMA_GTOH	0x2

/* chip interface structure for IP20 / HPC / WD33C93 */
typedef struct scuzzy {
	volatile unsigned char	*d_addr;	/* address register */
	volatile unsigned char	*d_data;	/* data register */
	volatile unsigned long	*d_ctrl;	/* control address */
	volatile unsigned long	*d_bcnt;	/* byte count register */
	volatile unsigned long	*d_curbp;	/* current buffer pointer */
	volatile unsigned long	*d_nextbp;	/* next buffer pointer */
	volatile unsigned long	*d_pntr;	/* fifo pointer register */
	volatile unsigned long	*d_fifo;	/* fifo data register */
	unsigned char d_initflags;	/* initial flags for d_flags */
	unsigned char d_clock;	/* value for clock register on WD chip */
} scuzzy_t;

/* descriptor structure for IP20 SCSI / HPC interface */
#ifdef	_MIPSEB
typedef struct scsi_descr {
	unsigned fill:19, bcnt:13;
	unsigned eox:1, efill:3, cbp:28;
	unsigned nfill:4, nbp:28;
} scdescr_t;
#else	/* _MIPSEL */
typedef struct scsi_descr {
	unsigned bcnt:13, fill:19;
	unsigned cbp:28, efill:3, eox:1;
	unsigned nbp:28, nfill:4;
} scdescr_t;
#endif	/* _MIPSEL */


#define NSCSI_DMA_PGS 64	/* map up to 256Kb per transfer.  This is sufficient
	for almost all disk and tape acesses.  Things like scanners or
	printers often transfer far more than a Mb per cmd, so they will
	have to re-map anyway, no matter how many we allocate */


/* this saves a lot of hard to read and type code in various places,
	and also ensures that we get the register size correct */
#define K1_LIO_0_MASK_ADDR ((volatile unchar *)PHYS_TO_K1(LIO_0_MASK_ADDR))
#define K1_LIO_1_MASK_ADDR ((volatile unchar *)PHYS_TO_K1(LIO_1_MASK_ADDR))
#define K1_LIO_0_ISR_ADDR ((volatile unchar *)PHYS_TO_K1(LIO_0_ISR_ADDR))
#define K1_LIO_1_ISR_ADDR ((volatile unchar *)PHYS_TO_K1(LIO_1_ISR_ADDR))

/*
 * IP20 ECC error handler defines.
 * Define an additional exception frame for the ECC handler.
 * Save 3 more registers on this frame: C0_CACHE_ERR, C0_TAGLO,
 * and C0_ECC.
 * Call this an ECCF_FRAME.
 */
#define ECCF_CACHE_ERR	0
#define ECCF_TAGLO	1
#define ECCF_ECC	2
#define ECCF_ERROREPC	3
#define ECCF_PADDR	4
#define ECCF_SIZE	(5 * 4)

/* Location of the eframe and stack for the ecc handler.
 * Since the R4000 'replaces' KUSEG with an unmapped, uncached space
 * corresponding to physical memory when a cache error occurs, these are
 * the actual addresses used.
 */
#define CACHE_ERR_EFRAME	(0x1000 - EF_SIZE)
#define CACHE_ERR_ECCFRAME	(CACHE_ERR_EFRAME - ECCF_SIZE)

/* 4 arguments on the stack. */
#define CACHE_ERR_SP		(CACHE_ERR_ECCFRAME - 4 * sizeof(int))

/* Mask to remove SW bits from pte. Note that the high-order
 * address bits are overloaded with SW bits, which limits the
 * physical addresses to 32 bits
 */
#define	TLBLO_HWBITS		0x03ffffff	/* 20 bit ppn, plus CDVG */
#define TLBLO_HWBITSHIFT	6		/* A shift value, for masking */
#define TLBLO_PFNTOKDMSHFT	6		/* tlblo pfn to direct mapped */

/* function prototypes for IP20 functions */

extern int spllintr(void);
extern int splhintr(void);
extern int splretr(void);

extern void setlclvector(int, void (*)(int,struct eframe_s *), int);
extern void setgiovector(int, int, void (*)(int), int);
extern void setgioconfig(int, int);

#define MCREGWBUG 

#ifndef MCREGWBUG
#define writemcreg(reg,val) (*(uint *)(PHYS_TO_K1(reg)) = (val))
#else

/*
 * Write to an MC register .  This is a workaround
 * for a bug in first rev of Blackjack hw.
 *
 * Ex: writemcreg (DMA_MODE, 0x50);
 */
extern void writemcreg(unsigned int, unsigned int);

#endif	/* MCREGWBUG

/*
 * Graphics DMA channel descriptor array element.
 * Stolen from IP12.h to facilitate PIC-style DMA.
 * We won't need this after VDMA virtual addressing
 * problem is fixed.
 */

#define PICGDMA_GTOH    0x2000          /* DMA Mode: 1 = Gfx to Host */
#define GDMA_LAST       0x8000          /* Marks last desc array entry */
#define GDMA_FULLPG     0x40000000      /* Full page (4k) DMA */

typedef struct gdmada {
        long *bufaddr;
        long dmactl;
        long grxaddr;
#ifdef  _MIPSEB
        unsigned short stride;
        unsigned short linecount;
#else   /* _MIPSEL */
        unsigned short linecount;
        unsigned short stride;
#endif  /* _MIPSEL */
        long *nextdesc;
} gdmada_t;




#endif /* LANGUAGE_C */

#if defined(STANDALONE) || defined(PROM) || defined(LOCORE)
#include <sys/IP20nvram.h>
#endif /* STANDALONE */

#endif /* __SYS_IP20_H__ */
