#ident "$Revision: 3.7 $"

/*
 * The kernel writes out an array of these structures to dbgmon memory
 * at startup, so that dbgmon knows where to find various structures.
 * Remember to change stand/symmon/idbg.h if this file is changed
 */
typedef struct {
	int	s_type;
	union {
		int	(*s_f1)();
		int	s_gpa;
	} un;
# define s_func		un.s_f1
# define s_gp		un.s_gpa
	char	s_name[8];
} dbgoff_t;

# define	DO_ENV		0x45454545	/* first record */
# define	DO_END		0x54545454	/* final record */

#ifndef STANDALONE
#define NBREAKPOINTS	32
struct brkpt_table {
	unsigned bt_addr;		/* address where brkpt is installed */
	unsigned bt_inst;		/* previous instruction */
	int bt_type;			/* breakpoint type */
	int bt_oldtype;			/* type before being suspended */
	int bt_cpu;		/* for which cpu(s) - bit mask */
};

/* stole from symmon/brkpt.c */
#define	BTTYPE_EMPTY	0		/* unused entry */
#define	BTTYPE_SUSPEND	1		/* suspended breakpoint */
#define	BTTYPE_CONT	2		/* continue breakpoint */
#define	BTTYPE_TEMP	3		/* temporary breakpoint */
#endif

/*
 * structure for commmunication between user idbg and internal
 */
struct idbgcomm {
	int	i_func;		/* function index into dbgoff_t table */
	int	i_arg;		/* 1st arg */
	caddr_t	i_argp;		/* pointer to i_argcnt pairs of addr,len */
	int	i_argcnt;	/* addr/len pairs */
	caddr_t i_uaddr;	/* where to put output */
	unsigned i_ulen;	/* length of user's buffer */
	int	i_cause;	/* set to cause reg if error else 0 */
	unsigned i_badvaddr;	/* where address error was if got one */
};
