/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*
 * imon.h - inode monitor definitions
 *
 * $Revision: 1.4 $
 * $Date: 1990/12/11 16:22:46 $
 */

#ifndef IMON_H
#define IMON_H

typedef ushort intmask_t;

/* Interest mask bits */
#define IMON_CONTENT	(1 << 0)	/* contents or size have changed */
#define IMON_ATTRIBUTE	(1 << 1)	/* mode or ownership have changed */
#define IMON_DELETE	(1 << 2)	/* last link has gone away */
#define IMON_EXEC	(1 << 3)	/* process executing */
#define IMON_EXIT	(1 << 4)	/* last process exited */
#define	IMON_RENAME	(1 << 5)	/* inode has been renamed */
#define	IMON_COLLISION	(1 << 15)	/* internal hash collision flag */
#define IMON_OVER	0xff		/* queue has overflowed */

#define IMON_ALL	0xff

/* Event queue element */
typedef struct {
	ino_t		qe_inode;	/* inode number of file */
	dev_t		qe_dev;		/* device of file */
	intmask_t	qe_what;	/* what events occurred */
	} qelem_t;

/* Imon ioctls */
#define IMONIOC_EXPRESS	(('i' << 8) | 1)
#define IMONIOC_REVOKE	(('i' << 8) | 2)
#define IMONIOC_QTEST	(('i' << 8) | 3)

/* interest structure for express/delete */
typedef struct {
	char *		in_fname;	/* pathname */
	struct stat *	in_sb;		/* optional status return buffer */
	intmask_t	in_what;	/* what types of events to send */
	} interest_t;
#endif
