
/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

/**************************************************************************
 *									  *
 *	kb.h - keyboard pseduo-driver defines				  *
 *									  *
 **************************************************************************/
#ident "$Revision: 1.7 $"

#define BITSPERBYTE 8
#define KB_MAXKEY 128
#define KEYBITMAPSIZE ( ( KB_MAXKEY + BITSPERBYTE - 1 ) / BITSPERBYTE )
struct _kb_state {
	unsigned short int repdelay ;	/* in units of lbolt ticks */
	unsigned short int repeat_rate ;/* in units of lbolt ticks */
	int reptid ;			/* autorepeat's ID on callout chain */
	int seqid;			/* sequence id counter */
	struct shmiqlinkid shmiqid ;	/* Stuff to play by the shmiq rules */
	struct queue *rq ;
	unsigned char keystate[ KEYBITMAPSIZE ] ;
	unsigned char repeatable[ KEYBITMAPSIZE ] ;
	unsigned char lastchar ;	/* autorepeat's arg on callout chain */
} ;

#define	KBGETREPEATABLES _IOR('Q',0,char [KEYBITMAPSIZE])
#define	KBSETREPEATABLES _IOW('Q',0,char [KEYBITMAPSIZE])
#define	KBGETREPEATRATES _IOR('Q',1,unsigned short int [2])
#define	KBSETREPEATRATES _IOW('Q',1,unsigned short int [2])

#define UPSTROKE 0x80

/* Enforced by the driver */
#define MINIMUM_REPEAT_DELAY (HZ/30) /* after ~1/30 a second */
#define MAXIMUM_REPEAT_RATE  (HZ/50) /* ~ 50 times a second */

/* these defaults are meant to closely match the rate the hardware repeats */
/* hardware delay is .65 seconds, and repeat is 28 times per second */
#define DEFAULT_REPEAT_DELAY (HZ*2/3)  /* after ~2/3 a second */
#define DEFAULT_REPEAT_RATE  (HZ/25)  /* ~ 25 times a second */
