/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
#ifndef __SYS_REG_H__
#define __SYS_REG_H__
#ident	"$Revision: 3.6 $"

/*
 * Location of the users' stored
 * registers in exception frame.
 * Usage is u.u_ar0[XX] or USER_REG(x).
 */

#define	EF_ARGSAVE0	0		/* arg save for c calling seq */
#define	EF_ARGSAVE1	1		/* arg save for c calling seq */
#define	EF_ARGSAVE2	2		/* arg save for c calling seq */
#define	EF_ARGSAVE3	3		/* arg save for c calling seq */
#define	EF_AT		4		/* r1:  assembler temporary */
#define	EF_V0		5		/* r2:  return value 0 */
#define	EF_V1		6		/* r3:  return value 1 */
#define	EF_A0		7		/* r4:  argument 0 */
#define	EF_A1		8		/* r5:  argument 1 */
#define	EF_A2		9		/* r6:  argument 2 */
#define	EF_A3		10		/* r7:  argument 3 */
#define	EF_T0		11		/* r8:  caller saved 0 */
#define	EF_T1		12		/* r9:  caller saved 1 */
#define	EF_T2		13		/* r10: caller saved 2 */
#define	EF_T3		14		/* r11: caller saved 3 */
#define	EF_T4		15		/* r12: caller saved 4 */
#define	EF_T5		16		/* r13: caller saved 5 */
#define	EF_T6		17		/* r14: caller saved 6 */
#define	EF_T7		18		/* r15: caller saved 7 */
#define	EF_S0		19		/* r16: callee saved 0 */
#define	EF_S1		20		/* r17: callee saved 1 */
#define	EF_S2		21		/* r18: callee saved 2 */
#define	EF_S3		22		/* r19: callee saved 3 */
#define	EF_S4		23		/* r20: callee saved 4 */
#define	EF_S5		24		/* r21: callee saved 5 */
#define	EF_S6		25		/* r22: callee saved 6 */
#define	EF_S7		26		/* r23: callee saved 7 */
#define	EF_T8		27		/* r24: code generator 0 */
#define	EF_T9		28		/* r25: code generator 1 */
#define	EF_K0		29		/* r26: kernel temporary 0 */
#define	EF_K1		30		/* r27: kernel temporary 1 */
#define	EF_GP		31		/* r28: global pointer */
#define	EF_SP		32		/* r29: stack pointer */
#define	EF_FP		33		/* r30: frame pointer */
#define	EF_RA		34		/* r31: return address */

#define	EF_SR		35		/* status register */
#define	EF_MDLO		36		/* low mult result */
#define	EF_MDHI		37		/* high mult result */
#define	EF_BADVADDR	38		/* bad virtual address */
#define	EF_CAUSE	39		/* cause register */
#define	EF_EPC		40		/* program counter */
#define	EF_SAVEDPC	41		/* saved program counter (for dbx) */
#define EF_LIOMSK	42		/* IP6 local interrupt mask reg */

#define	EF_SIZE		(43*4)		/* size of exception frame */
#define EF_ELEM		(43)		/* # registers in ex frame */

#define	USER_REG(x)	(u.u_eframe[(x)])

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)
/*
 * struct equiv for eframe - used mainly by debuggers
 */
struct eframe_s {
	int	ef_argsave0;
	int	ef_argsave1;
	int	ef_argsave2;
	int	ef_argsave3;
	int	ef_at;
	int	ef_v0;
	int	ef_v1;
	int	ef_a0;
	int	ef_a1;
	int	ef_a2;
	int	ef_a3;
	int	ef_t0;
	int	ef_t1;
	int	ef_t2;
	int	ef_t3;
	int	ef_t4;
	int	ef_t5;
	int	ef_t6;
	int	ef_t7;
	int	ef_s0;
	int	ef_s1;
	int	ef_s2;
	int	ef_s3;
	int	ef_s4;
	int	ef_s5;
	int	ef_s6;
	int	ef_s7;
	int	ef_t8;
	int	ef_t9;
	int	ef_k0;
	int	ef_k1;
	int	ef_gp;
	int	ef_sp;
	int	ef_fp;
	int	ef_ra;
	int	ef_sr;
	int	ef_mdlo;
	int	ef_mdhi;
	int	ef_badvaddr;
	int	ef_cause;
	int	ef_epc;
	int	ef_savedpc;
	int	ef_liomsk;
};
#endif /* _LANGUAGE_C || _LANGUAGE_C_PLUS_PLUS */
#endif /* __SYS_REG_H__ */
