/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

/*
 *	Include file for STREAMS on multiprocessors
 *
 *	$Revision: 1.8 $
 */

#ifndef __SYS_STRMP_H__
#define __SYS_STRMP_H__

#if defined(IP5)

#include "sys/sema.h"

#define MP_STREAMS

extern mon_t streams_mon;
extern int streams_interrupt();
extern int streams_service(struct strint *);
extern void streams_fired();
extern char qqrun;

struct strintr {
	struct strintr *next;
	int (*func)();
	void *arg1;
	void *arg2;
	void *arg3;
};

#define STREAMS_BLOCKQ()
#define STREAMS_UNBLOCKQ()
#define STREAMS_LOCK()			pmonitor(&streams_mon,PZERO)
#define STREAMS_UNLOCK()		vmonitor(&streams_mon)
#define STREAMS_TIMEOUT(f,a,t)	      cputimeout(streams_fired,f,t,a)
#define STREAMS_TIMEOUT1(f,a,t,a1)    cputimeout(streams_fired,f,t,a,a1)
#define STREAMS_TIMEOUT2(f,a,t,a1,a2) cputimeout(streams_fired,f,t,a,a1,a2)
#define STREAMS_DELAY(t)		streams_delay(t)
#define STREAMS_COPYIN(s,d,l)		streams_copyin(s,d,l)
#define STREAMS_COPYOUT(s,d,l)		streams_copyout(s,d,l)
#define STREAMS_IOMOVE(c,n,f)		{				\
						STREAMS_UNLOCK();	\
						iomove(c,n,f);		\
						STREAMS_LOCK();		\
					}

#else	/* No locking */

#undef MP_STREAMS

#define STREAMS_BLOCKQ()			s = spl1()
#define STREAMS_UNBLOCKQ()			(void)splx(s)
#define STREAMS_LOCK()
#define STREAMS_UNLOCK()
#define STREAMS_TIMEOUT(f,a,t)		timeout(f,a,t)
#define STREAMS_TIMEOUT1(f,a,t,a1)	timeout(f,a,t,a1)
#define STREAMS_TIMEOUT2(f,a,t,a1,a2)	timeout(f,a,t,a1,a2)
#define STREAMS_DELAY(t)		delay(t)
#define STREAMS_COPYIN(s,d,l)		copyin(s,d,l)
#define STREAMS_COPYOUT(s,d,l)		copyout(s,d,l)
#define STREAMS_IOMOVE(c,n,f)		iomove(c,n,f)

#endif

#endif /* __SYS_STRMP_H__ */
