/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*
 * Copyright 1985 by MIPS Computer Systems, Inc.
 */
#ifndef __SYS_SYSCALL_H__
#define __SYS_SYSCALL_H__
#ident	"$Revision: 1.12 $"

#if defined(_LANGUAGE_ASSEMBLY)
/*
 * SYSCALL -- standard system call sequence
 * The kernel expects arguments to be passed with the normal C calling
 * sequence.  v0 should contain the system call number.  On return from
 * the kernel mode, a3 will be 0 to indicate no error and non-zero to
 * indicate an error; if an error occurred v0 will contain an errno.
 */
#define	SYSCALL(x)					\
LEAF(x);						\
	li	v0,SYS_/**/x;				\
	syscall;					\
	beq	a3,zero,9f;				\
	j	_cerror;				\
9:

/*
 * PSEUDO -- system call sequence for syscalls that are variations of other
 * system calls
 */
#define	PSEUDO(x,y)					\
LEAF(x);						\
	li	v0,SYS_/**/y;				\
	syscall

#define	CALL(y)						\
	jal	y

#define	RET(x)						\
	j	ra;					\
	.end	x

	.globl	_cerror

#endif

/*
 * Rest of file for /proc system call tracing and kernel syscall table
 */
#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)

#ifndef _KERNEL
/*
 * The /proc syscall numbers start from 2 onwards. 2 corresponds to bit 1
 * (assuming an integer's bits are numbered 0..31 with 0 being the LSB)
 * in sysset_t since it gets decremented by 1  in praddset (sys/procfs.h).
 * Thus we maintain compatibility with the old /debug syscall numbers
 * (which start with 1) since the same bit would be set for both 
 * the /debug and /proc interfaces.
 */
#include <sys.s>	/* syscall numbers with kernel offset SYSVoffset */
#undef SYSVoffset
#define SYSVoffset	1
#endif /* !_KERNEL */

typedef struct {
	unsigned long word[16];
} sysset_t;


#ifdef _KERNEL
/*
 * Structure of the system-entry table
 */
extern struct sysent {
	char	sy_narg;	/* total number of arguments */
	char	sy_flags;	/* various flag bits (see below) */
	int	(*sy_call)();	/* handler */
} sysent[];

#define	SY_SETJMP	0x01	/* if setjmp() is necessary before syscall */
#define	SY_INDIR	0x02	/* another routine will do demultiplexing */
#define	SY_1STRING	0x04	/* first parameter is a string (for par) */
#define	SY_2STRING	0x08	/* first two parameters are strings (for par) */

#endif /* _KERNEL */

#endif /* language C */
#endif /* __SYS_SYSCALL_H__ */
