/**************************************************************************
 *									  *
 * 		 Copyright (C) 1986, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Revision: 3.10 $"

#ifndef __SYSMACROS_H__
#define __SYSMACROS_H__

/*
 * Some macros for units conversion
 */

/* a click is a page.  A segment is area mapped by a click of ptes (2Meg)*/
/* Core clicks to segments and vice versa */

#ifdef CPSSHIFT
#define ctos(x)		(((x) + (NCPS-1)) >> CPSSHIFT)
#define	ctost(x)	((x) >> CPSSHIFT)
#define	stoc(x)		((x) << CPSSHIFT)
#else
#define ctos(x)		(((x) + (NCPS-1)) / NCPS)
#define	ctost(x)	((x) / NCPS)
#define	stoc(x)		((x) * NCPS)
#endif

/* bytes to truncated pages - same as btoct */
#define btotp(x)	((unsigned)(x)>>BPTSHFT)

/* bytes to segments and vice-versa XXX - should we really mask?? */
#define stob(x)		(((unsigned)(x) & 0x7ff) * NBPS)
#define btos(x)		(((((unsigned)(x)) + (NBPS-1)) / NBPS) & 0x7ff)
#define btost(x)	((((unsigned)(x)) / NBPS) & 0x7ff)

/* true if 2 virtual addresses lie in the same segment */
#define samesegment(a,b) (((uint)(a) & ~SOFFMASK) == ((uint)(b) & ~SOFFMASK))

/* return # pages required to span a given addr/length */
#define numpages(v,l)	btoc((((unsigned)(v)) & (NBPC - 1)) + (l))

/* Core clicks to disk blocks */
#define	ctod(x) ((x)*NDPC)

/* inumber to disk address */
#ifdef INOSHIFT
#define	itod(x)	(daddr_t)(((unsigned)(x)+(2*INOPB-1))>>INOSHIFT)
#else
#define	itod(x)	(daddr_t)(((unsigned)(x)+(2*INOPB-1))/INOPB)
#endif

/* inumber to disk offset */
#ifdef INOSHIFT
#define	itoo(x)	(int)(((unsigned)(x)+(2*INOPB-1))&(INOPB-1))
#else
#define	itoo(x)	(int)(((unsigned)(x)+(2*INOPB-1))%INOPB)
#endif

/* clicks to bytes */
#ifdef BPCSHIFT
#define	ctob(x)	((x)<<BPCSHIFT)
#else
#define	ctob(x)	((x)*NBPC)
#endif

/* bytes to clicks */
#ifdef BPCSHIFT
#define	btoc(x)		(((unsigned)(x)+(NBPC-1))>>BPCSHIFT)
#define	btoct(x)	((unsigned)(x)>>BPCSHIFT)
#else
#define	btoc(x)		(((unsigned)(x)+(NBPC-1))/NBPC)
#define	btoct(x)	((unsigned)(x)/NBPC)
#endif

#ifdef _KERNEL

/* major part of a device internal to the kernel */
extern char MAJOR[128];
#define	major(x)	(int)(MAJOR[(unsigned)((x)>>8)&0x7F])
#define	bmajor(x)	(int)(MAJOR[(unsigned)((x)>>8)&0x7F])

#else

/* major part of a device external from the kernel */
#define	major(x)	(int)(((unsigned)(x)>>8)&0x7F)

#endif	/* _KERNEL */

/* minor part of a device */
#define	minor(x)	(int)((x)&0xFF)

/* make a device number */
#define	makedev(x,y)	(dev_t)(((x)<<8) | (y))

/*
 *   emajor() allows kernel/driver code to print external major numbers
 *   eminor() allows kernel/driver code to print external minor numbers
 */

#define emajor(x)	(int)(((unsigned)(x)>>8)&0x7F)
#define eminor(x)	(int)((x)&0xFF)

#define	server()	(0)

#define CLOSEI(ip, flag, count, offset) \
{ \
	FS_CLOSEI(ip, flag, count, offset); \
}

#define OPENI(ip, mode) \
{ \
	FS_OPENI(ip, mode); \
}

#define WRITEI(ip) \
{ \
	FS_WRITEI(ip); \
}

#define ITRUNC(ip) \
{ \
	FS_ITRUNC(ip); \
}

#define IPUT(ip) \
{ \
	FS_IPUT(ip); \
}

#define FREESP(ip, arg, flag, offset) \
{ \
	FS_FCNTL(ip, F_FREESP, arg, flag, offset); \
}

#endif /* __SYSMACROS_H__ */
