/**************************************************************************
 *									  *
 * 		 Copyright (C) 1989, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef __SYS_SYSTM_H__
#define __SYS_SYSTM_H__
#pragma once
#ident	"$Revision: 3.33 $"

/*
 * Variables and function prototypes
 */

extern struct inode *rootdir;	/* pointer to inode of root directory */
extern short cputype;		/* type of cpu = 40, 45, 70, 780, 0x3b5 */

extern short kdebug;		/* is kernel debugger active */
extern time_t lbolt;		/* time in HZ since last boot */
extern time_t time;		/* time in sec from 1970 */
extern int tick;		/* microseconds in a clock tick */
extern lock_t timelock;		/* lock for time variables */

extern time_t boottime;		/* time of system boot */
extern time_t forktime;		/* time of last fork */

extern		maxmem;		/* max available memory (clicks) */
extern		physmem;	/* physical memory (clicks) on this CPU */
extern		maxclick;	/* Highest physical click + 1.		*/
extern		firstclick;	/* address of first memory location in click */
extern daddr_t	swplo;		/* block number of start of swap space */
extern		nswap;		/* size of swap space in blocks*/
extern dev_t	rootdev;	/* device of the root */
extern dev_t	swapdev;	/* swapping device */
extern dev_t	pipedev;	/* pipe device */
extern dev_t	dumpdev;	/* dump device */
extern long	dumplo;		/* location on dump device where dump starts */
extern char	*panicstr;	/* panic string pointer */
extern int	showconfig;
extern int	restricted_chown; /* 1 ==> restrictive chown(2) semantics */
extern int	cachewrback;	/* writeback cache flag */

extern	void	*kern_calloc(size_t, size_t);
extern	void	*kern_malloc(size_t);
extern	void	*dmabuf_malloc(size_t);
extern	void	*kern_realloc(void *, size_t);
extern	void	kern_free(void *);
extern	int	sleep(void *, int);
extern	int	wakeup(void *);

extern int splhi(void);
extern int spl0(void);
extern int spl1(void);
extern int spl2(void);
extern int spl3(void);
extern int spl4(void);
extern int spl5(void);
extern int spl6(void);
extern int spl65(void);
extern int spl7(void);
extern int splvme(void);
extern int splnet(void);
extern int spltty(void);
extern int splimp(void);
extern int splprof(void);
extern void splx(int);

extern void clean_icache(void *, unsigned int, unsigned int);
extern void clean_dcache(void *, unsigned int, unsigned int);
extern void cacheinit(void);
extern void bclean_icache(void *, unsigned int, unsigned int);
extern void bclean_dcache(void *, unsigned int, unsigned int);
extern void unuseracc(void *, uint, int);
extern int useracc(void *, uint, int);
extern int userdma(void *, uint, int);
extern void undma(void *, uint, int);

#if !defined(R4000)
extern void viflush(void *, unsigned int);
extern void vflush(void *, unsigned int);
#endif

#ifndef icache_inval
extern void icache_inval(void *, unsigned int);
#endif
#ifndef dcache_inval
extern void dcache_inval(void *, unsigned int);
#endif
#ifndef dcache_wb
extern void dcache_wb(void *, unsigned int);
#endif
#ifndef dcache_wbinval
extern void dcache_wbinval(void *, unsigned int);
#endif

extern int badaddr(volatile void *addr, int len);

extern void hwcpin(volatile void *src, void *dst, int len);
extern void hwcpout(void *src, volatile void *dst, int len);

extern int copyout(void *src,void *dst, int len);
extern int copyin(void *src, void *dst, int len);
extern int fuword(void *);
extern int fuiword(void *);
extern int fuibyte(void *);
extern int fubyte(void *);
extern int suword(void *, uint);
extern int suiword(void *, uint);
extern int suhalf(void *, ushort);
extern int subyte(void *, unchar);

/* printing/error routines */
extern void cmn_err(int, char *, ...);
extern void sprintf(char *, char *, ...);
extern void printf(char *, ...);
extern void dri_printf(char *, ...);
extern void prdev(char *, int, ...);	/* 2nd arg is really dev_t */
extern void panic(char *, ...);
extern void conbuf_flush(int);
extern char *stdname(char *, char *, int, int, int);
extern void prom_reboot(void);
extern void nomemmsg(char *, char *);
extern void _assfail(char *, char *, int);

/* total misc homeless routines */
extern void kickidle(void);
extern int suser(void);
extern unsigned llemulate(unsigned, uint *);
extern void preemptchk(void);
extern void force_resched(void);

/* I/O */
extern int physio();
#define STRATEGY_RETURN void
extern int iphysio(STRATEGY_RETURN (*)(), struct buf *, dev_t, int, daddr_t);
extern int physck(daddr_t, int);

/* timers */
extern void clkstart(void);
extern void clkset(time_t);
extern void clkreld(void);
extern void timepoke(void);
extern void fast_timepoke(void);
extern void idle(void);
extern void startrtclock(void);
extern void stopclocks(void);
extern void startkgclock(void);
extern void slowkgclock(void);

/*
 * Structure of probeable-addresses list.
 * This defines non-VME, non KSEG[012] addresses
 * which are probeable (by /dev/kmem et al).
 */
struct kmem_ioaddr {
	unsigned long	v_base;
	unsigned long	v_length;	/* in bytes */
};

extern struct kmem_ioaddr kmem_ioaddr[];

#endif /* __SYS_SYSTM_H__ */
