#ifndef __SYS_TIMES_H__
#define __SYS_TIMES_H__

#ifdef __cplusplus
extern "C" {
#endif

/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* sys/times.h */

#ident	"$Revision: 3.11 $"

#include <sys/types.h>

#ifndef _CLOCK_T_
#define _CLOCK_T_
typedef long	clock_t;
#endif /* !_CLOCK_T_ */

/*
 * Structure returned by times()
 */
struct tms {
	clock_t	tms_utime;		/* user time */
	clock_t	tms_stime;		/* system time */
	clock_t	tms_cutime;		/* user time, children */
	clock_t	tms_cstime;		/* system time, children */
};

#ifndef _KERNEL
extern clock_t	times (struct tms *);
#endif /* !_KERNEL */

#ifdef __cplusplus
}
#endif

#endif /* !__SYS_TIMES_H__ */
